; ---USAGE---

; python3 ok <name_of_function>

; e.g. python3 ok hailstone

; ---NOTES---

; - if you want to see the verbose output, run this:

;     python3 ok <name_of_function> -v

; - if you want to test all of your functions, run this:

;     python3 ok

;

;;; Discussion 11 - Introduction to Scheme ;;;

; Q2 - hailstone
;;; Tests
; (hailstone 10 0)
; expect 10
; (hailstone 10 1)
; expect 5
; (hailstone 10 2)
; expect 16
; (hailstone 5 1)
; expect 16

(define (hailstone seed n)
  (if (= n 0)
    seed
    (if (= 0 (remainder seed 2))
      (hailstone
      (quotient seed 2)
      (- n 1))
     (hailstone
     (+ 1 (* seed 3))
     (- n 1))
    )
  )
)

; Q4 - waldo
;;; Tests
; (waldo '(1 4 waldo))
; expect #t
; (waldo '())
; expect #f
; (waldo '(1 4 9))
; expect #f

(define (waldo lst)
  (cond ((null? lst) #f)
    ((eq? (car lst) 'waldo) #t)
    (else (waldo (cdr lst)))
  )
)

; Alternate solution (using `if`):

; (define (waldo lst)
;   (if (null? lst)
;     #f
;     (if (eq? (car lst) 'waldo)
;       #t
;       (waldo (cdr lst))
;     )
;   )
; )

; Q5 - waldo-challenge
;;; Tests
; (waldo-challenge '(1 4 waldo))
; expect 2
; (waldo-challenge '())
; expect #f
; (waldo-challenge '(1 4 9))
; expect #f

(define (waldo-challenge lst)
  (define (helper lst index)
    (cond ((null? lst) #f)
      ((eq? (car lst) 'waldo) index)
      (else (helper (cdr lst) (+ index 1)))
    )
  )
  (helper lst 0)
)

; Alternate solution (no helper):

; (define (waldo-challenge lst)
;   (cond
;     ((null? lst) #f)
;     ((eq? 'waldo (car lst)) 0)
;     (else (if (waldo-challenge (cdr lst))
;       (+ 1 (waldo-challenge (cdr lst)))
;       #f)
;     )
;   )
; )